CREATE OR REPLACE  FUNCTION CRMOD 
 (XVal IN NUMBER, 
  YVal IN NUMBER) 
RETURN NUMBER
AS
BEGIN
   RETURN MOD(ROUND(XVal),ROUND(YVal)); 
END; 
/
CREATE OR REPLACE  FUNCTION INT_DIV
 (Numerator IN NUMBER,
  Denominator IN NUMBER)
RETURN NUMBER
AS
BEGIN
 RETURN FLOOR(ROUND(Numerator)/ROUND(Denominator));
END;
/
CREATE OR REPLACE  FUNCTION PERCENT
 (Numerator IN NUMBER, 
  Denominator IN NUMBER) 
RETURN NUMBER
AS
BEGIN
 RETURN 100*(Numerator/Denominator); 
END;
/
CREATE OR REPLACE  FUNCTION TIMESTAMP_TO_DATE
 (TimestampVar IN TIMESTAMP)
RETURN DATE
AS
BEGIN
 RETURN TO_DATE(TO_CHAR(TimestampVar,'DD-MON-YYYY HH24:MI:SS'),
                'DD-MON-YYYY HH24:MI:SS');
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_YEARS
 (IntervalVar IN INTERVAL YEAR TO MONTH)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(YEAR FROM IntervalVar) 
         +EXTRACT(MONTH FROM IntervalVar)/12;
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_MONTHS
 (IntervalVar IN INTERVAL YEAR TO MONTH)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(YEAR FROM IntervalVar)*12 
         +EXTRACT(MONTH FROM IntervalVar);
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_DAYS
 (IntervalVar IN INTERVAL DAY TO SECOND)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(DAY FROM IntervalVar)
       +EXTRACT(HOUR FROM IntervalVar)/24
       +EXTRACT(MINUTE FROM IntervalVar)/(24*60)
       +EXTRACT(SECOND FROM IntervalVar)/(24*60*60);
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_HOURS
 (IntervalVar IN INTERVAL DAY TO SECOND)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(DAY FROM IntervalVar)*24
       +EXTRACT(HOUR FROM IntervalVar)
       +EXTRACT(MINUTE FROM IntervalVar)/60
       +EXTRACT(SECOND FROM IntervalVar)/(60*60);
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_MINUTES
 (IntervalVar IN INTERVAL DAY TO SECOND)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(DAY FROM IntervalVar)*24*60
       +EXTRACT(HOUR FROM IntervalVar)*60
       +EXTRACT(MINUTE FROM IntervalVar)
       +EXTRACT(SECOND FROM IntervalVar)/60;
END;
/
CREATE OR REPLACE  FUNCTION INTERVAL_TO_SECONDS
 (IntervalVar IN INTERVAL DAY TO SECOND)
RETURN NUMBER
AS
BEGIN
 RETURN EXTRACT(DAY FROM IntervalVar)*60*60*24
       +EXTRACT(HOUR FROM IntervalVar)*60*60
       +EXTRACT(MINUTE FROM IntervalVar)*60
       +EXTRACT(SECOND FROM IntervalVar);
END;
/