
  CREATE OR REPLACE TYPE "XTREME"."PHONE_REC" AS OBJECT ( "PHONE_TYPE" VARCHAR2(20), "PHONE_NO" VARCHAR2(20) )
/

 
  CREATE OR REPLACE TYPE "XTREME"."CONTACT_REC" AS OBJECT ( "CONTACT_ID" NUMBER(2, 0), "PHONE_NO" "XTREME"."PHONE_REC" )
/

 
  CREATE TABLE "XTREME"."CONTACT_OBJECT_TABLE" OF "XTREME"."CONTACT_REC" 
 ;
 GRANT SELECT ON "XTREME"."CONTACT_OBJECT_TABLE" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."CREDIT" 
   (	"CREDIT_AUTHORIZATION_NUMBER" VARCHAR2(10), 
	"CUSTOMER_CREDIT_ID" NUMBER(10,0), 
	"AMOUNT" NUMBER(19,4), 
	 CONSTRAINT "CREDIT_PK" PRIMARY KEY ("CREDIT_AUTHORIZATION_NUMBER") ENABLE
   ) ;
  GRANT SELECT ON "XTREME"."CREDIT" TO XTREME_REPORTER;

 
  CREATE TABLE "XTREME"."CUSTOMER" 
   (	"CUSTOMER_ID" NUMBER(10,0), 
	"CUSTOMER_CREDIT_ID" NUMBER(10,0), 
	"CUSTOMER_NAME" VARCHAR2(40), 
	"CONTACT_FIRST_NAME" VARCHAR2(30), 
	"CONTACT_LAST_NAME" VARCHAR2(30), 
	"CONTACT_TITLE" VARCHAR2(5), 
	"CONTACT_POSITION" VARCHAR2(30), 
	"LAST_YEARS_SALES" NUMBER(19,4), 
	"ADDRESS1" VARCHAR2(60), 
	"ADDRESS2" VARCHAR2(20), 
	"CITY" VARCHAR2(20), 
	"REGION" VARCHAR2(30), 
	"COUNTRY" VARCHAR2(30), 
	"POSTAL_CODE" VARCHAR2(10), 
	"E-MAIL" VARCHAR2(50), 
	"WEB_SITE" VARCHAR2(50), 
	"PHONE" VARCHAR2(20), 
	"FAX" VARCHAR2(20), 
	 CONSTRAINT "CUSTOMER_PK" PRIMARY KEY ("CUSTOMER_ID") ENABLE
   ) ;
  GRANT SELECT ON "XTREME"."CUSTOMER" TO XTREME_REPORTER;
 
CREATE OR REPLACE VIEW "XTREME"."CREDIT_LIMITS" ("AMOUNT",
    "CREDIT_AUTHORIZATION_NUMBER","CONTACT_FIRST_NAME",
    "CONTACT_LAST_NAME","CUSTOMER_NAME") AS 
    SELECT XTREME.CREDIT.AMOUNT,   
    XTREME.CREDIT.CREDIT_AUTHORIZATION_NUMBER,   
    XTREME.CUSTOMER.CONTACT_FIRST_NAME,   
    XTREME.CUSTOMER.CONTACT_LAST_NAME,   
    XTREME.CUSTOMER.CUSTOMER_NAME   
    FROM XTREME.CREDIT, XTREME.CUSTOMER   
    WHERE XTREME.CREDIT.CUSTOMER_CREDIT_ID=XTREME.CUSTOMER.CUSTOMER_CREDIT_ID WITH READ ONLY;

  GRANT SELECT ON "XTREME"."CREDIT_LIMITS" TO XTREME_REPORTER;
 
  CREATE INDEX "XTREME"."CREDT_CUSTOMER_CREDIT_ID_INDEX" ON "XTREME"."CREDIT" ("CUSTOMER_CREDIT_ID") 
  ;
 
  CREATE INDEX "XTREME"."CUSTOMER_CUSTOMER_CREDIT_ID" ON "XTREME"."CUSTOMER" ("CUSTOMER_CREDIT_ID") 
  ;
 
  CREATE INDEX "XTREME"."CUSTOMER_POSTAL_CODE" ON "XTREME"."CUSTOMER" ("POSTAL_CODE") 
  ;
 
  CREATE TABLE "XTREME"."EMPLOYEE" 
   (	"EMPLOYEE_ID" NUMBER(10,0) DEFAULT 0 NOT NULL ENABLE, 
	"SUPERVISOR_ID" NUMBER(10,0) DEFAULT 0, 
	"LAST_NAME" VARCHAR2(20) NOT NULL ENABLE, 
	"FIRST_NAME" VARCHAR2(10) NOT NULL ENABLE, 
	"POSITION" VARCHAR2(30), 
	"BIRTH_DATE" DATE, 
	"HIRE_DATE" DATE, 
	"HOME_PHONE" VARCHAR2(20), 
	"EXTENSION" VARCHAR2(4), 
	"PHOTO" BLOB, 
	"NOTES" CLOB, 
	"REPORTS_TO" NUMBER(10,0), 
	"SALARY" NUMBER(19,4), 
	"SSN" VARCHAR2(12), 
	"EMERGENCY_CONTACT_FIRST_NAME" VARCHAR2(20), 
	"EMERGENCY_CONTACT_LAST_NAME" VARCHAR2(20), 
	"EMERGENCY_CONTACT_RELATIONSHIP" VARCHAR2(20), 
	"EMERGENCY_CONTACT_PHONE" VARCHAR2(20), 
	 CONSTRAINT "EMPLOYEE_PK" PRIMARY KEY ("EMPLOYEE_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."EMPLOYEE" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."EMPLOYEE_ADDRESSES" 
   (	"EMPLOYEE_ID" NUMBER(10,0), 
	"ADDREES1" VARCHAR2(60), 
	"ADDRESS2" VARCHAR2(20), 
	"CITY" VARCHAR2(15), 
	"REGION" VARCHAR2(15), 
	"COUNTRY" VARCHAR2(15), 
	"POSTAL_CODE" VARCHAR2(10), 
	"EMERGENCY_CONTACT_ADDRESS1" VARCHAR2(60), 
	"EMERGENCY_CONTACT_ADDRESS2" VARCHAR2(20), 
	"EMERGENCY_CONTACT_CITY" VARCHAR2(15), 
	"EMERGENCY_CONTACT_REGION" VARCHAR2(15), 
	"EMERGENCY_CONTACT_COUNTRY" VARCHAR2(15), 
	"EMERGENCY_CONTACT_POSTAL_CODE" VARCHAR2(10), 
	 CONSTRAINT "EMPLOYEE_ADDRESSES_PK" PRIMARY KEY ("EMPLOYEE_ID") ENABLE, 
	 CONSTRAINT "EMPLOYEE_ADDRESSES_EMPLOYE_FK" FOREIGN KEY ("EMPLOYEE_ID")
	  REFERENCES "XTREME"."EMPLOYEE" ("EMPLOYEE_ID") ENABLE
   ) ;
 
  GRANT SELECT ON "XTREME"."EMPLOYEE_ADDRESSES" TO XTREME_REPORTER;

  CREATE INDEX "XTREME"."EMPLOYEE_ADDRESSES_INDEX1" ON "XTREME"."EMPLOYEE_ADDRESSES" ("EMERGENCY_CONTACT_POSTAL_CODE") 
  ;
 
  CREATE INDEX "XTREME"."EMPLOYEE_ADDRESSES_INDEXTREME" ON "XTREME"."EMPLOYEE_ADDRESSES" ("POSTAL_CODE") 
  ;
 
  CREATE INDEX "XTREME"."EMPLOYEE_REPORTS_TO_INDEX" ON "XTREME"."EMPLOYEE" ("REPORTS_TO") 
  ;
 
  CREATE INDEX "XTREME"."EMPLOYEE_SUPERVISOR_ID_INDEX" ON "XTREME"."EMPLOYEE" ("SUPERVISOR_ID") 
  ;
 
  CREATE OR REPLACE TYPE "XTREME"."PHONE_ARRAY_TYPE" AS VARRAY (5) OF "XTREME"."PHONE_REC"
/

 
  CREATE TABLE "XTREME"."EMPLOYEE_WITH_PHONES_ARRAY" 
   (	"EMPLOYEE_ID" NUMBER(10,0) DEFAULT 0 NOT NULL ENABLE, 
	"SUPERVISOR_ID" NUMBER(10,0) DEFAULT 0, 
	"LAST_NAME" VARCHAR2(20) NOT NULL ENABLE, 
	"FIRST_NAME" VARCHAR2(10) NOT NULL ENABLE, 
	"POSITION" VARCHAR2(30), 
	"BIRTH_DATE" DATE, 
	"HIRE_DATE" DATE,
	"EXTENSION" VARCHAR2(4), 
	"PHOTO" BLOB, 
	"NOTES" CLOB, 
	"REPORTS_TO" NUMBER(10,0), 
	"SALARY" NUMBER(19,4), 
	"SSN" VARCHAR2(12), 
	"EMERGENCY_CONTACT_FIRST_NAME" VARCHAR2(20), 
	"EMERGENCY_CONTACT_LAST_NAME" VARCHAR2(20), 
	"EMERGENCY_CONTACT_RELATIONSHIP" VARCHAR2(20),
	"PHONES" "XTREME"."PHONE_ARRAY_TYPE" ,
	"PHONE_RECORD" "XTREME"."PHONE_REC" , 
	 CONSTRAINT "EMPLOYEE2_PK_1" PRIMARY KEY ("EMPLOYEE_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."EMPLOYEE_WITH_PHONES_ARRAY" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."FINANCIALS" 
   (	"COMPANY_ID" VARCHAR2(5), 
	"STATEMENT_DATE" DATE, 
	"CASH" FLOAT(49), 
	"ACCOUNT_RECEIVABLE" FLOAT(49), 
	"INVENTORIES" FLOAT(49), 
	"OTHER_CURRENT_ASSETS" FLOAT(49), 
	"LAND" FLOAT(49), 
	"BUILDINGS" FLOAT(49), 
	"MACHINERY_ETC" FLOAT(49), 
	"ACCUMULATED_DEPRECIATION" FLOAT(49), 
	"OTHER_ASSETS" FLOAT(49), 
	"ACCOUNTS_PAYABLE" FLOAT(49), 
	"ACCRUED_LIABILITIES" FLOAT(49), 
	"ACCRUED_INCOME_TAXES" FLOAT(49), 
	"NOTES_PAYABLE" FLOAT(49), 
	"DEFERRED_INCOME_TAXES" FLOAT(49), 
	"PREFERRED_STOCK" FLOAT(49), 
	"COMMON_STOCK" FLOAT(49), 
	"RETAINED_EARNINGS" FLOAT(49), 
	"NET_SALES" FLOAT(49), 
	"COGS" FLOAT(49), 
	"SELLING/ADMIN/GENERAL_EXPENSES" FLOAT(49), 
	"DEPRECIATION" FLOAT(49), 
	"INTEREST_EXPENSES" FLOAT(49), 
	"OTHER_INCOME_EXPENSES" FLOAT(49), 
	"TAXES" FLOAT(49)
   ) ;

  GRANT SELECT ON "XTREME"."FINANCIALS" TO XTREME_REPORTER;
 
  CREATE INDEX "XTREME"."FINANCIALS_COMPANY_ID_INDEX" ON "XTREME"."FINANCIALS" ("COMPANY_ID") 
  ;
 

  CREATE TABLE "XTREME"."ORDERS" 
   (     "ORDER_ID" NUMBER(10) NOT NULL, 
         "ORDER_AMOUNT" NUMBER(19, 4),
         "CUSTOMER_ID" NUMBER(10), 
         "EMPLOYEE_ID" NUMBER(10),
         "ORDER_DATE" DATE,
         "REQUIRED_DATE" DATE,
         "SHIP_DATE" DATE,
         "COURIER_WEBSITE" VARCHAR2(50), 
         "SHIP_VIA" VARCHAR2(20),
         "SHIPPED" NUMBER(3) NOT NULL, 
         "PO#" VARCHAR2(50),
         "PAYMENT_RECEIVED" NUMBER(3) NOT NULL, 
      CONSTRAINT "ORDERS_CUSTOMER_FK" FOREIGN KEY("CUSTOMER_ID") 
        REFERENCES "XTREME"."CUSTOMER"("CUSTOMER_ID"), 
      CONSTRAINT "ORDERS_EMPLOYEE_FK" FOREIGN KEY("EMPLOYEE_ID") 
        REFERENCES "XTREME"."EMPLOYEE"("EMPLOYEE_ID"), 
      CONSTRAINT "ORDERS_PK" PRIMARY KEY("ORDER_ID")
    ) ;

  GRANT SELECT ON "XTREME"."ORDERS" TO XTREME_REPORTER;

  CREATE MATERIALIZED VIEW LOG
    ON XTREME.ORDERS 
  TABLESPACE USERS 
  WITH ROWID, PRIMARY KEY ( ORDER_DATE, ORDER_AMOUNT) 
  INCLUDING NEW VALUES;

  CREATE MATERIALIZED VIEW "XTREME"."ORDERS_MONTH_TOTALS_YESTERDAY"
  BUILD IMMEDIATE  
  REFRESH COMPLETE  
  NEXT TRUNC(sysdate+1)+1/24 
  AS
  Select extract(year from order_date) as order_year,
         extract(month from order_date) as order_month,
         sum(order_amount) as month_amount
    from orders
   group by extract(year from order_date),
         extract(month from order_date);

  GRANT SELECT ON "XTREME"."ORDERS_MONTH_TOTALS_YESTERDAY" TO XTREME_REPORTER;
 
  CREATE MATERIALIZED VIEW "XTREME"."ORDERS_MONTH_TOTALS_ONDEMAND"
  BUILD IMMEDIATE  
  REFRESH ON DEMAND 
  AS
  Select extract(year from order_date) as order_year,
         extract(month from order_date) as order_month,
         sum(order_amount) as month_amount
    from orders
   group by extract(year from order_date),
         extract(month from order_date);

  GRANT SELECT ON "XTREME"."ORDERS_MONTH_TOTALS_ONDEMAND" TO XTREME_REPORTER;
 
  CREATE MATERIALIZED VIEW XTREME.ORDERS_MONTH_TOTALS_ONCOMMIT 
  BUILD IMMEDIATE  
  REFRESH FAST 
  ON COMMIT 
  AS
  SELECT EXTRACT(YEAR FROM order_date) AS order_year,
         EXTRACT(MONTH FROM order_date) AS order_month,
         SUM(order_amount) AS month_amount,
         COUNT(*) AS Row_Count,
         COUNT(order_amount) AS Amount_Count
    FROM orders
   GROUP BY EXTRACT(YEAR FROM order_date),
         EXTRACT(MONTH FROM order_date);

  GRANT SELECT ON "XTREME"."ORDERS_MONTH_TOTALS_ONCOMMIT" TO XTREME_REPORTER;
 
  CREATE MATERIALIZED VIEW XTREME.ORDERS_MONTH_TOTALS_REWRITE 
  BUILD IMMEDIATE  
  REFRESH FAST 
  ON DEMAND  
  ENABLE QUERY REWRITE 
  AS
  SELECT EXTRACT(YEAR FROM order_date) AS order_year,
         EXTRACT(MONTH FROM order_date) AS order_month,
         SUM(order_amount) AS month_amount,
         COUNT(*) AS Row_Count,
         COUNT(order_amount) AS Amount_Count
    FROM orders
   GROUP BY EXTRACT(YEAR FROM order_date),
         EXTRACT(MONTH FROM order_date);

  GRANT SELECT ON "XTREME"."ORDERS_MONTH_TOTALS_REWRITE" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."PRODUCT_TYPE" 
   (	"PRODUCT_TYPE_ID" NUMBER(10,0) NOT NULL ENABLE, 
	"PRODUCT_TYPE_NAME" VARCHAR2(50), 
	"DESCRIPTION" CLOB, 
	"PICTURE" BLOB, 
	 CONSTRAINT "PRODUCT_TYPE_PK" PRIMARY KEY ("PRODUCT_TYPE_ID") ENABLE
   ) ;
 
  GRANT SELECT ON "XTREME"."PRODUCT_TYPE" TO XTREME_REPORTER;

  CREATE TABLE "XTREME"."SUPPLIER" 
   (	"SUPPLIER_ID" NUMBER(10,0) NOT NULL ENABLE, 
	"SUPPLIER_NAME" VARCHAR2(50), 
	"ADDRESS1" VARCHAR2(50), 
	"ADDRESS2" VARCHAR2(50), 
	"CITY" VARCHAR2(50), 
	"REGION" VARCHAR2(50), 
	"COUNTRY" VARCHAR2(50), 
	"POSTAL_CODE" VARCHAR2(50), 
	"PHONE" VARCHAR2(20), 
	 CONSTRAINT "SUPPLIER_PK" PRIMARY KEY ("SUPPLIER_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."SUPPLIER" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."PRODUCT" 
   (	"PRODUCT_ID" NUMBER(10,0), 
	"PRODUCT_NAME" VARCHAR2(50), 
	"COLOR" VARCHAR2(20), 
	"SIZE" VARCHAR2(10), 
	"M/F" VARCHAR2(10), 
	"PRICE_SRP" NUMBER(19,4), 
	"PRODUCT_TYPE_ID" NUMBER(10,0), 
	"PRODUCT_CLASS" VARCHAR2(50), 
	"SUPPLIER_ID" NUMBER(10,0), 
	 CONSTRAINT "PRODUCT_PK" PRIMARY KEY ("PRODUCT_ID") ENABLE, 
	 CONSTRAINT "PRODUCT_PRODUCT_TYPE_FK" FOREIGN KEY ("PRODUCT_TYPE_ID")
	  REFERENCES "XTREME"."PRODUCT_TYPE" ("PRODUCT_TYPE_ID") ENABLE, 
	 CONSTRAINT "PRODUCT_SUPPLIER_FK" FOREIGN KEY ("SUPPLIER_ID")
	  REFERENCES "XTREME"."SUPPLIER" ("SUPPLIER_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."PRODUCT" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."ORDERS_DETAIL" 
   (	"ORDER_ID" NUMBER(10,0), 
	"PRODUCT_ID" NUMBER(10,0), 
	"UNIT_PRICE" NUMBER(19,4), 
	"QUANTITY" NUMBER(10,0), 
	 CONSTRAINT "ORDERS_DETAIL_PK" PRIMARY KEY ("ORDER_ID", "PRODUCT_ID") ENABLE, 
	 CONSTRAINT "ORDERS_DETAIL_PRODUCT_FK" FOREIGN KEY ("PRODUCT_ID")
	  REFERENCES "XTREME"."PRODUCT" ("PRODUCT_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."ORDERS_DETAIL" TO XTREME_REPORTER;
 
CREATE OR REPLACE VIEW "XTREME"."LIST_TOTALS" ("EXPR1",
    "ORDER_ID") AS 
    SELECT SUM(XTREME.ORDERS_DETAIL.QUANTITY*  
    XTREME.ORDERS_DETAIL.UNIT_PRICE) AS EXPR1, 
     XTREME.ORDERS.ORDER_ID  
    FROM XTREME.ORDERS, XTREME.ORDERS_DETAIL 
    WHERE XTREME.ORDERS.ORDER_ID=XTREME.ORDERS_DETAIL.ORDER_ID 
            GROUP BY XTREME.ORDERS.ORDER_ID WITH READ ONLY;

  GRANT SELECT ON "XTREME"."LIST_TOTALS" TO XTREME_REPORTER;
 
  CREATE INDEX "XTREME"."ORDERS_DETAIL_ORDER_ID_INDEX" ON "XTREME"."ORDERS_DETAIL" ("ORDER_ID") 
  ;
 
  CREATE INDEX "XTREME"."ORDERS_DETAIL_PRODUCT_ID_INDEX" ON "XTREME"."ORDERS_DETAIL" ("PRODUCT_ID") 
  ;
 
  CREATE OR REPLACE FORCE VIEW "XTREME"."PHONES_FROM_ARRAY" ("EMPLOYEE_ID", "PHONE_TYPE", "PHONE_NO") AS 
  SELECT E.EMPLOYEE_ID, P.*
    FROM XTREME.EMPLOYEE_WITH_PHONES_ARRAY  E,
                TABLE(E.PHONES) P
    WITH READ ONLY
;

  GRANT SELECT ON "XTREME"."PHONES_FROM_ARRAY" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."PHONE_OBJECT_TABLE" OF "XTREME"."PHONE_REC" 
 ;

  GRANT SELECT ON "XTREME"."PHONE_OBJECT_TABLE" TO XTREME_REPORTER;
 
  CREATE OR REPLACE TYPE "XTREME"."PHONE_TABLE" AS TABLE OF "XTREME"."PHONE_REC"
/

 
  CREATE INDEX "XTREME"."PRODUCT_PRODUCT_TYPE_ID_INDEX" ON "XTREME"."PRODUCT" ("PRODUCT_TYPE_ID") 
  ;
 
  CREATE INDEX "XTREME"."PRODUCT_SUPPLIER_ID_INDEX" ON "XTREME"."PRODUCT" ("SUPPLIER_ID") 
  ;
 
  CREATE TABLE "XTREME"."PURCHASES" 
   (	"PRODUCT_ID" NUMBER(10,0), 
	"REORDER_LEVEL" NUMBER(10,0), 
	"UNITS_IN_STOCK" NUMBER(10,0), 
	"UNITS_ON_ORDER" NUMBER(10,0), 
	"PO#" NUMBER(10,0), 
	"ORDER_DATE" DATE, 
	"EXPECTED_RECEIVING_DATE" DATE, 
	"RECEIVED" NUMBER(3,0) NOT NULL ENABLE, 
	"PAID" NUMBER(3,0) NOT NULL ENABLE, 
	 CONSTRAINT "PURCHASES_PK" PRIMARY KEY ("PRODUCT_ID") ENABLE, 
	 CONSTRAINT "PURCHASES_PRODUCT_FK" FOREIGN KEY ("PRODUCT_ID")
	  REFERENCES "XTREME"."PRODUCT" ("PRODUCT_ID") ENABLE
   ) ;

  GRANT SELECT ON "XTREME"."PURCHASES" TO XTREME_REPORTER;

  CREATE GLOBAL TEMPORARY TABLE "XTREME"."NUMBER_PARAM_TEMP" 
   (	"NUMBER_PARAM" NUMBER(10,0) NOT NULL ENABLE, 
	 CONSTRAINT "NUMBER_PARAM_TEMP_PK" PRIMARY KEY ("NUMBER_PARAM") ENABLE
   )  ON COMMIT PRESERVE ROWS;

  GRANT SELECT ON "XTREME"."NUMBER_PARAM_TEMP" TO XTREME_REPORTER;
 
  CREATE OR REPLACE TYPE "XTREME"."NUMBER_PARAM_TABLE_TYPE" AS TABLE OF NUMBER
/

 
  CREATE OR REPLACE PACKAGE "XTREME"."TOOLS" AS
  FUNCTION PARAM_TO_NUM_PARAM_TABLE_TYPE(Param IN VARCHAR2)
    RETURN NUMBER_PARAM_TABLE_TYPE;
    
  PROCEDURE PARAM_TO_NUMBER_PARAM_TEMP(Param IN VARCHAR2); 
  
TYPE AUDSID_Rec_Type IS RECORD
  (AUDSID  Number);

TYPE AUDSID_Rpt_Type IS REF CURSOR RETURN AUDSID_Rec_Type;

PROCEDURE AUDSID_Report
  (AUDSID_Rpt_Cur IN OUT AUDSID_Rpt_Type); 
END;
/

  GRANT EXECUTE ON "XTREME"."TOOLS" TO XTREME_REPORTER;

CREATE OR REPLACE PACKAGE BODY "XTREME"."TOOLS" AS
  FUNCTION PARAM_TO_NUM_PARAM_TABLE_TYPE(Param IN VARCHAR2)
    RETURN NUMBER_PARAM_TABLE_TYPE
    IS
      Param_Str VARCHAR2(32767);
      Param_Table NUMBER_PARAM_TABLE_TYPE := NUMBER_PARAM_TABLE_TYPE();
      Comma_Position NUMBER;
    BEGIN
      Param_Str:=Param||',';
      LOOP
        Comma_Position := INSTR(Param_Str, ',');
        EXIT WHEN (NVL(Comma_Position, 0)) = 0;
        Param_Table.EXTEND;
        Param_Table(Param_Table.COUNT) := TRIM(SUBSTR(Param_Str, 1, Comma_Position-1));
        Param_Str := SUBSTR(Param_Str, Comma_Position+1);
      END LOOP;
      RETURN Param_Table;
    END PARAM_TO_NUM_PARAM_TABLE_TYPE;
    
  PROCEDURE PARAM_TO_NUMBER_PARAM_TEMP(Param IN VARCHAR2)
  IS
    Param_Str VARCHAR2(32767);
    Comma_Position NUMBER;
  BEGIN
    DELETE FROM Number_Param_Temp;
    Param_Str:=Param||',';
    LOOP
      Comma_Position := INSTR(Param_Str, ',');
      EXIT WHEN (NVL(Comma_Position, 0)) = 0;
      INSERT INTO Number_Param_Temp VALUES (TRIM(SUBSTR(Param_Str, 1, Comma_Position-1)));
      Param_Str := SUBSTR(Param_Str, Comma_Position+1);
    END LOOP;
  END PARAM_TO_NUMBER_PARAM_TEMP;  
  
  PROCEDURE AUDSID_Report
  (AUDSID_Rpt_Cur IN OUT AUDSID_Rpt_Type)
  IS
  BEGIN
    Open AUDSID_Rpt_Cur FOR
      Select USERENV('SESSIONID') AUDSID
        from Dual;
  END AUDSID_Report; 
END;
/
 
  CREATE OR REPLACE PACKAGE "XTREME"."REPORTS" AS

TYPE Supp_Rpt_Rec_Type IS RECORD
  (Supplier_ID   Supplier.Supplier_ID%TYPE,
   Supplier_Name Supplier.Supplier_Name%Type,
   Country       Supplier.Country%Type,
   Phone         Supplier.Phone%Type,
   AUSID         number);

TYPE Supp_Rpt_Type IS REF CURSOR RETURN Supp_Rpt_Rec_Type;

PROCEDURE Supplier_Report
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     Supplier.Supplier_Id%TYPE);
   
PROCEDURE Supplier_Multi_Report_1
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     VARCHAR2); 
   
PROCEDURE Supplier_Multi_Report_2
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     VARCHAR2);     
   
TYPE Supp_Rpt_Weak_Type IS REF CURSOR;

PROCEDURE Supplier_Weak_Report
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Weak_Type,
   SupplierVar  IN     Supplier.Supplier_Id%TYPE);   
   
TYPE Orders_Rpt_Rec_Type IS RECORD
  (Order_ID         ORDERS.ORDER_ID%TYPE,
   Order_Amount     ORDERS.ORDER_AMOUNT%Type,
   Customer_ID      ORDERS.CUSTOMER_ID%Type,
   Employee_ID      ORDERS.EMPLOYEE_ID%Type,
   Order_Date       ORDERS.ORDER_DATE%Type,
   Required_Date    ORDERS.REQUIRED_DATE%Type,
   Ship_Date        ORDERS.SHIP_DATE%Type,
   Ship_Via         ORDERS.SHIP_VIA%Type,
   PO#              ORDERS.PO#%Type,
   Payment_Received ORDERS.PAYMENT_RECEIVED%Type,
   Shipped          ORDERS.SHIPPED%Type,
   AUDSID        number);

TYPE Orders_Rpt_Type IS REF CURSOR RETURN Orders_Rpt_Rec_Type;

PROCEDURE Orders_Report
  (Orders_Rpt_Cur IN OUT Orders_Rpt_Type,
   Shipped_Var    IN     ORDERS.SHIPPED%Type);
   
PROCEDURE Orders_After_Report
  (Orders_Rpt_Cur IN OUT Orders_Rpt_Type,
   After_Date     IN     ORDERS.ORDER_DATE%Type);   
   
TYPE Emp_Rpt_Rec_Type IS RECORD
  (Employee_ID   Employee.Employee_ID%TYPE,
   Photo         Employee.Photo%Type,
   AUDSID         number);

TYPE Emp_Rpt_Type IS REF CURSOR RETURN Emp_Rpt_Rec_Type;

PROCEDURE Employee_Report
  (Emp_Rpt_Cur IN OUT Emp_Rpt_Type);   
  
TYPE Customers_In_Region_Rpt_Type IS REF CURSOR RETURN Customer%ROWTYPE;

PROCEDURE Customers_In_Region_Report
  (Customers_In_Region_Cur IN OUT Customers_In_Region_Rpt_Type,
   In_Region                IN Customer.Region%Type,
   In_Country               IN Customer.Country%Type DEFAULT 'USA');
   
END REPORTS;
/

  GRANT EXECUTE ON "XTREME"."REPORTS" TO XTREME_REPORTER;


CREATE OR REPLACE PACKAGE BODY "XTREME"."REPORTS" AS

PROCEDURE Supplier_Report
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     Supplier.Supplier_Id%TYPE)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier
       where Supplier_ID=SupplierVar;
  END Supplier_Report;
  
PROCEDURE Supplier_Multi_Report_1
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     VARCHAR2)
IS
  BEGIN
    TOOLS.PARAM_TO_NUMBER_PARAM_TEMP(SupplierVar);
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier, Number_Param_Temp
       Where (supplier.supplier_id=Number_Param_Temp.Number_Param);
  END Supplier_Multi_Report_1;  
  
PROCEDURE Supplier_Multi_Report_2
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Type,
   SupplierVar  IN     VARCHAR2)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier 
       Where Supplier_id IN
              (Select * from TABLE(TOOLS.PARAM_TO_NUM_PARAM_TABLE_TYPE(SupplierVar))); 
  END Supplier_Multi_Report_2;  
  
PROCEDURE Supplier_Weak_Report
  (Supp_Rpt_Cur IN OUT Supp_Rpt_Weak_Type,
   SupplierVar  IN     Supplier.Supplier_Id%TYPE)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier
       where Supplier_ID=SupplierVar;
  END Supplier_Weak_Report;  
  
PROCEDURE Orders_Report
  (Orders_Rpt_Cur IN OUT Orders_Rpt_Type,
   Shipped_Var    IN     ORDERS.SHIPPED%TYPE)
IS
  BEGIN
    Open Orders_Rpt_Cur for
       SELECT ORDER_ID, ORDER_AMOUNT, CUSTOMER_ID, EMPLOYEE_ID,
              ORDER_DATE, REQUIRED_DATE, SHIP_DATE, SHIP_VIA,
              PO#, PAYMENT_RECEIVED, SHIPPED, (USERENV('SESSIONID'))
       FROM   XTREME.ORDERS
       WHERE  SHIPPED=Shipped_Var;
  END Orders_Report; 
  
PROCEDURE Orders_After_Report
  (Orders_Rpt_Cur IN OUT Orders_Rpt_Type,
   After_Date     IN     ORDERS.ORDER_DATE%Type) 
IS
  BEGIN
    Open Orders_Rpt_Cur for
       SELECT ORDER_ID, ORDER_AMOUNT, CUSTOMER_ID, EMPLOYEE_ID,
              ORDER_DATE, REQUIRED_DATE, SHIP_DATE, SHIP_VIA,
              PO#, PAYMENT_RECEIVED, SHIPPED, (USERENV('SESSIONID'))
       FROM   XTREME.ORDERS
       WHERE  ORDER_DATE > After_Date;
  END Orders_After_Report;     
  
PROCEDURE Employee_Report
  (Emp_Rpt_Cur IN OUT Emp_Rpt_Type)
IS
  BEGIN
    Open Emp_Rpt_Cur for
      Select Employee_ID, Photo,
             userenv('sessionid') AUDSID
        from Employee;
  END Employee_Report;  

PROCEDURE Customers_In_Region_Report
  (Customers_In_Region_Cur IN OUT Customers_In_Region_Rpt_Type,
   In_Region                IN Customer.Region%Type,
   In_Country               IN Customer.Country%Type DEFAULT 'USA')
IS
  BEGIN
    Open Customers_In_Region_Cur for
      Select * from Customer
       Where Country = In_Country
         and Region  = In_Region;
  END Customers_In_Region_Report;  
  
END REPORTS;
/
 
  CREATE INDEX "XTREME"."SUPPLIER_POSTAL_CODE_INDEX" ON "XTREME"."SUPPLIER" ("POSTAL_CODE") 
  ;
 
  CREATE OR REPLACE PROCEDURE "XTREME"."SUPPLIER_REPORT" 
   (Supp_Rpt_Cur IN OUT Reports.Supp_Rpt_Type,
    SupplierVar  IN     Supplier.Supplier_Id%TYPE)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier
       where Supplier_ID=SupplierVar;
  END Supplier_Report;
/

  GRANT EXECUTE ON "XTREME"."SUPPLIER_REPORT" TO XTREME_REPORTER;
 
  CREATE OR REPLACE PACKAGE "XTREME"."SUPPLIER_RPTS" AS

TYPE Supp_Rpt_Rec_Type IS RECORD
  (Supplier_ID   Supplier.Supplier_ID%TYPE,
   Supplier_Name Supplier.Supplier_Name%Type,
   Country       Supplier.Country%Type,
   Phone         Supplier.Phone%Type,
   AUSID         number);

TYPE Supp_Rpt_Type IS REF CURSOR RETURN Supp_Rpt_Rec_Type;

PROCEDURE Supplier_Report
  (Supp_Rpt_Cur  OUT Supp_Rpt_Type,
   Supplier_Par IN     Supplier.Supplier_Id%TYPE);
   
END SUPPLIER_RPTS;
/

GRANT EXECUTE ON "XTREME"."SUPPLIER_RPTS" TO XTREME_REPORTER;

CREATE OR REPLACE PACKAGE BODY "XTREME"."SUPPLIER_RPTS" AS

PROCEDURE Supplier_Report
  (Supp_Rpt_Cur  OUT Supp_Rpt_Type,
   Supplier_Par IN     Supplier.Supplier_Id%TYPE)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier
       where Supplier_ID=Supplier_Par;
  END Supplier_Report;

END SUPPLIER_RPTS;
/
 
  CREATE OR REPLACE PACKAGE "XTREME"."SUPP_REV" AS

TYPE Supp_Rpt_Rec_Type IS RECORD
  (Supplier_ID   Supplier.Supplier_ID%TYPE,
   Supplier_Name Supplier.Supplier_Name%Type,
   Country       Supplier.Country%Type,
   Phone         Supplier.Phone%Type,
   AUSID         number);

TYPE Supp_Rpt_Type IS REF CURSOR;

PROCEDURE Supplier_Report
  (SupplierVar  IN     Supplier.Supplier_Id%TYPE,
   Supp_Rpt_Cur IN OUT Supp_Rpt_Type);
   
END SUPP_REV;
/

GRANT EXECUTE ON "XTREME"."SUPP_REV" TO XTREME_REPORTER;

CREATE OR REPLACE PACKAGE BODY "XTREME"."SUPP_REV" AS

PROCEDURE Supplier_Report
  (SupplierVar  IN     Supplier.Supplier_Id%TYPE,
   Supp_Rpt_Cur IN OUT Supp_Rpt_Type)
IS
  BEGIN
    Open Supp_Rpt_Cur for
      Select Supplier_ID, Supplier_Name,
             Country, Phone, userenv('sessionid') AUSID
        from Supplier
       where Supplier_ID=SupplierVar;  
  END Supplier_Report;

END SUPP_REV;
/

 

  CREATE OR REPLACE FORCE VIEW "XTREME"."TOP_CUSTOMERS" 
    ("ADDRESS1", "ADDRESS2", "CITY", "CONTACT_FIRST_NAME", "CONTACT_LAST_NAME",
     "CONTACT_POSITION", "CONTACT_TITLE", "COUNTRY", "CUSTOMER_CREDIT_ID", "CUSTOMER_ID",
     "CUSTOMER_NAME", "FAX", "LAST_YEARS_SALES", "PHONE", "POSTAL_CODE", "REGION") AS 
  SELECT XTREME.CUSTOMER.ADDRESS1, XTREME.CUSTOMER.ADDRESS2, XTREME.CUSTOMER.CITY, 
         XTREME.CUSTOMER.CONTACT_FIRST_NAME, XTREME.CUSTOMER.CONTACT_LAST_NAME, 
         XTREME.CUSTOMER.CONTACT_POSITION, XTREME.CUSTOMER.CONTACT_TITLE, XTREME.CUSTOMER.COUNTRY,
         XTREME.CUSTOMER.CUSTOMER_CREDIT_ID, XTREME.CUSTOMER.CUSTOMER_ID, XTREME.CUSTOMER.CUSTOMER_NAME,
         XTREME.CUSTOMER.FAX, XTREME.CUSTOMER.LAST_YEARS_SALES, XTREME.CUSTOMER.PHONE, 
         XTREME.CUSTOMER.POSTAL_CODE, XTREME.CUSTOMER.REGION 
    FROM XTREME.CUSTOMER 
   WHERE ( XTREME.CUSTOMER.LAST_YEARS_SALES > '50000' ) WITH READ ONLY;
 
GRANT SELECT ON "XTREME"."TOP_CUSTOMERS" TO XTREME_REPORTER;

  CREATE TABLE "XTREME"."XTREME_INFO" 
   (	"XTREME_NAME" VARCHAR2(50) NOT NULL ENABLE, 
	"ADDRESS" VARCHAR2(255), 
	"CITY" VARCHAR2(50), 
	"PROVINCE" VARCHAR2(50), 
	"COUNTRY" VARCHAR2(50), 
	"POSTAL_CODE" VARCHAR2(20), 
	"PHONE" VARCHAR2(20), 
	"FAX" VARCHAR2(20), 
	"LOGO_B/W" BLOB, 
	"LOGO_COLOR" BLOB, 
	 CONSTRAINT "XTREME_INFO_PK" PRIMARY KEY ("XTREME_NAME") ENABLE
   ) ;
 
GRANT SELECT ON "XTREME"."XTREME_INFO" TO XTREME_REPORTER;

  CREATE INDEX "XTREME"."XTREME_INFO_POSTAL_CODE_INDEX" ON "XTREME"."XTREME_INFO" ("POSTAL_CODE") 
  ;

  CREATE OR REPLACE FUNCTION "XTREME"."CRMOD" (
 XVal IN Number,
 YVal IN Number
)
return Number
as
begin
   Return MOD(ROUND(XVal),ROUND(YVal));
end;
/

GRANT EXECUTE ON "XTREME"."CRMOD" TO XTREME_REPORTER;
 
  CREATE SYNONYM "XTREME"."EMPLOYEES" FOR "XTREME"."EMPLOYEE"
 
   CREATE SEQUENCE  "XTREME"."EXAMPLE_SEQUENCE"  MINVALUE 1 MAXVALUE 1.00000000000000E+28 INCREMENT BY 1 START WITH 271 CACHE 20 NOORDER  NOCYCLE ;
 
 
  CREATE OR REPLACE FUNCTION "XTREME"."INT_DIV" (
 Numerator IN Number,
 Denominator IN Number
)
return Number
as
begin
 Return FLOOR(ROUND(Numerator)/ROUND(Denominator));
end;
/

GRANT EXECUTE ON "XTREME"."INT_DIV" TO XTREME_REPORTER;

  CREATE OR REPLACE FUNCTION "XTREME"."PERCENT" (
 Numerator IN Number,
 Denominator IN Number
 )
return Number
as
begin
 Return 100*(Numerator/Denominator);
end;
/
 
  CREATE TABLE "XTREME"."PLAN_TABLE" 
   (	"STATEMENT_ID" VARCHAR2(30), 
	"TIMESTAMP" DATE, 
	"REMARKS" VARCHAR2(80), 
	"OPERATION" VARCHAR2(30), 
	"OPTIONS" VARCHAR2(255), 
	"OBJECT_NODE" VARCHAR2(128), 
	"OBJECT_OWNER" VARCHAR2(30), 
	"OBJECT_NAME" VARCHAR2(30), 
	"OBJECT_INSTANCE" NUMBER(*,0), 
	"OBJECT_TYPE" VARCHAR2(30), 
	"OPTIMIZER" VARCHAR2(255), 
	"SEARCH_COLUMNS" NUMBER, 
	"ID" NUMBER(*,0), 
	"PARENT_ID" NUMBER(*,0), 
	"POSITION" NUMBER(*,0), 
	"COST" NUMBER(*,0), 
	"CARDINALITY" NUMBER(*,0), 
	"BYTES" NUMBER(*,0), 
	"OTHER_TAG" VARCHAR2(255), 
	"PARTITION_START" VARCHAR2(255), 
	"PARTITION_STOP" VARCHAR2(255), 
	"PARTITION_ID" NUMBER(*,0), 
	"OTHER" LONG, 
	"DISTRIBUTION" VARCHAR2(30), 
	"CPU_COST" NUMBER(*,0), 
	"IO_COST" NUMBER(*,0), 
	"TEMP_SPACE" NUMBER(*,0), 
	"ACCESS_PREDICATES" VARCHAR2(4000), 
	"FILTER_PREDICATES" VARCHAR2(4000)
   ) ;

GRANT SELECT, INSERT, UPDATE, DELETE ON "XTREME"."PLAN_TABLE" TO XTREME_REPORTER;

  CREATE TABLE "XTREME"."REWRITE_TABLE" 
   (	"STATEMENT_ID" VARCHAR2(30), 
	"MV_OWNER" VARCHAR2(30), 
	"MV_NAME" VARCHAR2(30), 
	"SEQUENCE" NUMBER(*,0), 
	"QUERY" VARCHAR2(2000), 
	"MESSAGE" VARCHAR2(512), 
	"PASS" VARCHAR2(3), 
	"FLAGS" NUMBER(*,0), 
	"RESERVED1" NUMBER(*,0), 
	"RESERVED2" VARCHAR2(10)
   ) ;

GRANT SELECT, INSERT, UPDATE, DELETE ON "XTREME"."REWRITE_TABLE" TO XTREME_REPORTER;
 
  CREATE TABLE "XTREME"."RPT_AUDIT" 
   (	"REPORT_NAME" VARCHAR2(50) NOT NULL ENABLE, 
	"RUN_DATE" DATE DEFAULT SYSDATE NOT NULL ENABLE
   ) ;

GRANT SELECT, INSERT, UPDATE, DELETE ON "XTREME"."RPT_AUDIT" TO XTREME_REPORTER;
 
 
  CREATE OR REPLACE FUNCTION "XTREME"."UPPER_FOR_NO" (
 StringVar IN varchar2, UpperLen IN number 
 )
return varchar2
as
begin
 Return Upper(Substr(StringVar,1,UpperLen))
  ||Substr(StringVar,UpperLen+1,Length(StringVar)-UpperLen);
end;
/

GRANT EXECUTE ON "XTREME"."UPPER_FOR_NO" TO XTREME_REPORTER;
 
  CREATE OR REPLACE PROCEDURE "XTREME"."UPPER_TEST" (
 CharString in out varchar2, UpperLen in Number
)
as
begin
 CharString:=Upper(Substr(CharString,1,UpperLen))
  ||Substr(CharString,UpperLen+1,Length(CharString)-UpperLen);
end;
/
GRANT EXECUTE ON "XTREME"."UPPER_TEST" TO XTREME_REPORTER;
