CREATE GLOBAL TEMPORARY TABLE OLD_VERSIONS 
  (OBJECT_ID VARCHAR2(50) NOT NULL, 
   VERSION NUMBER NOT NULL, 
   PRIMARY KEY(OBJECT_ID, VERSION))
  ON COMMIT DELETE ROWS;
/
CREATE OR REPLACE TRIGGER TRIGGER_30_ROW
 BEFORE INSERT ON COR.OR_OBJECTDETAILS_30 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);

  UPDATE COR.OR_OBJECTS
     SET Owner_ID=:NEW.Modifier_Name
   WHERE Object_ID=:NEW.Object_ID; 
   
  INSERT INTO COR.OLD_VERSIONS
   VALUES (:NEW.OBJECT_ID, :NEW.VERSION-1); 
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_30_UPDATE
 BEFORE UPDATE ON COR.OR_OBJECTDETAILS_30 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_30_STATEMENT
 AFTER INSERT ON COR.OR_OBJECTDETAILS_30
BEGIN
  FOR UPD IN (SELECT OBJECT_ID, VERSION FROM COR.OLD_VERSIONS) LOOP
    UPDATE COR.OR_OBJECTDETAILS_30
       SET Deleted=1
     WHERE OBJECT_ID=UPD.OBJECT_ID
       AND VERSION=UPD.VERSION; 
  END LOOP;     
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_31_ROW
 BEFORE INSERT ON COR.OR_OBJECTDETAILS_31 FOR EACH ROW 
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);

  UPDATE COR.OR_OBJECTS
     SET Owner_ID=:NEW.Modifier_Name
   WHERE Object_ID=:NEW.Object_ID; 
   
  INSERT INTO COR.Old_Versions
   VALUES (:NEW.OBJECT_ID, :NEW.VERSION-1); 
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_31_UPDATE
 BEFORE UPDATE ON COR.OR_OBJECTDETAILS_31 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_31_STATEMENT
 AFTER INSERT ON COR.OR_OBJECTDETAILS_31
BEGIN
  FOR UPD IN (SELECT OBJECT_ID, VERSION FROM COR.OLD_VERSIONS) LOOP
    UPDATE COR.OR_OBJECTDETAILS_31
       SET Deleted=1
     WHERE OBJECT_ID=UPD.OBJECT_ID
       AND VERSION=UPD.VERSION; 
  END LOOP;     
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_32_ROW
 BEFORE INSERT ON COR.OR_OBJECTDETAILS_32 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);

  UPDATE COR.OR_OBJECTS
     SET Owner_ID=:NEW.Modifier_Name
   WHERE Object_ID=:NEW.Object_ID; 
   
  INSERT INTO COR.Old_Versions
   VALUES (:NEW.OBJECT_ID, :NEW.VERSION-1); 
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_32_UPDATE
 BEFORE UPDATE ON COR.OR_OBJECTDETAILS_32 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_32_STATEMENT
 AFTER INSERT ON COR.OR_OBJECTDETAILS_32
BEGIN
  FOR UPD IN (SELECT OBJECT_ID, VERSION FROM COR.OLD_VERSIONS) LOOP
    UPDATE COR.OR_OBJECTDETAILS_32
       SET Deleted=1
     WHERE OBJECT_ID=UPD.OBJECT_ID
       AND VERSION=UPD.VERSION; 
  END LOOP;     
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_33_ROW
 BEFORE INSERT ON COR.OR_OBJECTDETAILS_33 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);

  UPDATE COR.OR_OBJECTS
     SET Owner_ID=:NEW.Modifier_Name
   WHERE Object_ID=:NEW.Object_ID; 
   
  INSERT INTO COR.Old_Versions
   VALUES (:NEW.OBJECT_ID, :NEW.VERSION-1); 
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_33_UPDATE
 BEFORE UPDATE ON COR.OR_OBJECTDETAILS_33 FOR EACH ROW
BEGIN
  :NEW.Modifier_Name:=UPPER(:NEW.Modifier_Name);
END;
/
CREATE OR REPLACE TRIGGER TRIGGER_33_STATEMENT
 AFTER INSERT ON COR.OR_OBJECTDETAILS_33
BEGIN
  FOR UPD IN (SELECT OBJECT_ID, VERSION FROM COR.OLD_VERSIONS) LOOP
    UPDATE COR.OR_OBJECTDETAILS_33
       SET Deleted=1
     WHERE OBJECT_ID=UPD.OBJECT_ID
       AND VERSION=UPD.VERSION; 
  END LOOP;     
END;
/
CREATE OR REPLACE TRIGGER OR_OBJECTS_TRIGGER
 BEFORE INSERT ON COR.OR_OBJECTS FOR EACH ROW
BEGIN
  :NEW.OWNER_ID:=UPPER(USER); 
END;
/
